package callserver;

import java.io.*;
import java.net.*;
import java.util.*;
import java.text.*; 

public class CallServer {
  private Socket smtpSocket = null;
  private DataOutputStream os = null;
  private DataInputStream is = null;
  public String hostName = "localhost";
  public int portNum     = 9999;
  public String subject  = "Order #232323 is now ready";
  public String sMessage = "Please report to the bar immediately to pick up" +
                           "your order!";
  
  Date dDate = new Date();
  DateFormat dFormat = DateFormat.getDateInstance(DateFormat.FULL,Locale.US);

  public boolean sendMessage() {
    try { 
      smtpSocket = new Socket(hostName, portNum);
      os = new DataOutputStream(smtpSocket.getOutputStream());
      is = new DataInputStream(smtpSocket.getInputStream());
            
      if(smtpSocket != null && os != null && is != null) {
        os.writeBytes("HELO\r\n");
        os.writeBytes("MAIL FROM: <Bartender@OpenBAR.org>\r\n");
        os.writeBytes("RCPT TO: <9083426615@tmomail.net>\r\n");      
        os.writeBytes("DATA\r\n");                  
        os.writeBytes("X-Mailer: Via Java\r\n");
        os.writeBytes("DATE: " + dFormat.format(dDate) + "\r\n");
        os.writeBytes("From: Chef <Chef@OpenBAR.org>\r\n");
        os.writeBytes("To: Server <Server@OpenBAR.org>\r\n");                                     
        os.writeBytes("Subject: "+subject+"\r\n");
        os.writeBytes(sMessage + "\r\n");
        os.writeBytes("\r\n.\r\n");
        os.writeBytes("QUIT\r\n");                    
        String responseline;
        while((responseline = is.readLine())!=null) {
          System.out.println(responseline);
        }        
      }
    } catch(Exception e) { 
      System.out.println("Host " + hostName + "unknown"); 
      return false;
    }    
    return true;
  }
    public CallServer() {
    }
    
}
