package startbuttons;

import java.awt.*;
import java.sql.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Date;
import java.sql.Timestamp;




public class CreateButtons implements ActionListener {
    ///////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////                   Declaring all Variables                  //////////////////////////

    protected JTextField k;
    protected DefaultListModel m;

    
    // Connect to the database
    protected StartDB db= new StartDB(); 
    
    // Create an object of insertDB so we can use it later to insert data into the database
    protected insertDB idb;
    
   
    protected String database_query1; 
    protected String pre_name1;
    protected String name1;
    protected ResultSet rs;
    protected int num_items=0;
    protected String[] db_names=new String[200];    
    
    protected String[] temp_items_names=new String[200]; 
    protected float[] temp_items_prices=new float[200]; 

    protected int ti_count=0;
    protected float ti_total=0;
    
    protected String item_ordered;                                        //The name of the item clicked by the bartender
    protected String query1;                                              //To be used for frequent queeries to the database    
   
    protected String query3;
   
    // create the variable that are going to generate the active orders in the database
    protected int oi=1;                                                   //order id
    protected int ti=2;                                                     //table id
    protected int ei=3;                                                     //employee id
   
    protected float ip;                                                   //item price
    protected Timestamp ct;
    
    // Variables to perform some math in calculating totals for current order
    protected float num1=0;                                                
    protected float num2=0;
    public float num3=0;
    
  
    protected String wb;
   
    
    ////////////////            All variables are declared              /////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    
    
    // Takes in a database query, and creates a jpanel based on the # of rows and cols, also gives the buttons names
    // based on the pre_name and the num of items generated in the panel.
    
    public CreateButtons() { }
    
    public CreateButtons(JPanel panel,String database_query,String pre_name,String name,int rows,int cols,JTextField total,DefaultListModel td_model) {
        database_query1=database_query;
        pre_name1=pre_name;
        name1=name;
        getButtonText();
        addButtons(panel,rows,cols);
        k=total;
        m=td_model;
    }
    
    
    public double getTotal() { return ti_total; }
    

    public void enterItems(){
        System.out.println("count: "+ti_count);
        for (int i=0; i< ti_count; i++)
        {
             //Insert items in the database to be added to the current order
            // Get current time
            ct = new Timestamp ( System.currentTimeMillis (  )  ) ; 
            query1="insert into active_orders values ('"+oi+"','"+ti+"','"+ei+"','"+temp_items_names[i]+"','"+ct+"','"+temp_items_prices[i]+"')";
            idb=new insertDB(query1);
            
        } 
    }
    
  
            
    public void actionPerformed(ActionEvent a) {
      
        //----Receive the name of the button clicked into the 'item_ordered'
        item_ordered=a.getActionCommand(); 
        
        query1="select * from `menu_items` where Item_name='"+item_ordered+"'";
        
        
        //---- perform query to get the item id when we have the items name
        try {
            Statement stmt = db.con.createStatement();
            rs = stmt.executeQuery(query1); 
            while (rs.next()) {
               
                 /*
                 Need to test here if it is time for specials
                 before we choose what price to pull out of database
                 */
                 ip =rs.getFloat("Regular_price");
            }       
          
        } catch (SQLException ex) { 
               System.err.print("SQLException: ");
               System.err.println(ex.getMessage());
        }  
        
        
        
        
        
        
        // Put the names of all temporary items
        temp_items_names[ti_count]=item_ordered;
        temp_items_prices[ti_count]=ip;
      
        
        System.out.println(temp_items_names[ti_count]+"  $"+temp_items_prices[ti_count]);
        
        m.addElement(temp_items_names[ti_count].toString()+"  $"+Double.toString(temp_items_prices[ti_count]));
        
        
        ti_count++;
        ti_total=ti_total+ip;
        k.setText(Float.toString(ti_total));
        
       
        
        
        }
    
    
    
       
   

    protected void getButtonText() {          
        try {
            Statement stmt = db.con.createStatement();
            rs = stmt.executeQuery(database_query1); 
            while (rs.next()) {
               String s = rs.getString(name1);   
               db_names[num_items]=s;
               num_items++;
            }       
        } catch (SQLException ex) { 
               System.err.print("SQLException: ");
               System.err.println(ex.getMessage());
        }            
    }
    
    public void addButtons(JPanel panel,int rows, int cols) {
        
        LayoutManager mgr = new GridLayout(rows,cols);
        panel.setSize(200,300);
        panel.setLayout(mgr);    
        
        for(int j=0;j<num_items;j++) {   
            JButton comp = new JButton();  
            comp.addActionListener(this);       
            comp.setName(pre_name1+num_items);
            panel.add(comp);               
            comp.setText(db_names[j]);            
            System.out.println("["+j+"]"+db_names[j]);
            
         }    
        
    }
        public void addButtons(JPanel panel,String database_query,String pre_name,String name,int rows,int cols) {
            db_names=new String[200];     
        num_items=0;
        database_query1=database_query;
        pre_name1=pre_name;
        name1=name;
        getButtonText();
        LayoutManager mgr = new GridLayout(rows,cols);
        panel.setSize(200,300);
        panel.setLayout(mgr);          
        for(int j=0;j<num_items;j++) {   
            JButton comp = new JButton();  
            comp.addActionListener(this);       
            comp.setName(pre_name1+num_items);
            panel.add(comp);               
            comp.setText(db_names[j]);            
            System.out.println("["+j+"]"+db_names[j]);
            
         }    
        
    }
}
