package startbuttons;

import java.awt.*;
import java.sql.*;
import javax.swing.*;
import java.awt.event.*;




public class CreateButtons implements ActionListener {
    

    // Connect to the database
    private StartDB db = new StartDB(); 
    
    // Declaring the variables used in this class
    private String database_query1; 
    private String pre_name1;
    private String name1;
    private ResultSet rs;
    private int num_items=0;
    private String[] db_names=new String[200];     
    
    private String item_ordered;                                        //The name of the item clicked by the bartender
    private String query1;
   
    // create the variable that are going to generate the active orders in the database
    private int oi;                                                     //order id
    private int ti;                                                     //table id
    private int ei;                                                     //employee id
    private int ii;                                                     //item id
    private float ip;                                                   //item price
    
    
    private String wb;
   
    
    // Takes in a database query, and creates a jpanel based on the # of rows and cols, also gives the buttons names
    // based on the pre_name and the num of items generated in the panel.
    public CreateButtons(JPanel panel,String database_query,String pre_name,String name,int rows,int cols) {
        database_query1=database_query;
        pre_name1=pre_name;
        name1=name;
        getButtonText();
        addButtons(panel,rows,cols);
    }
    
    
    
    //When an item is chosen, ...
    
    public void actionPerformed(ActionEvent a) {
        int Item_id;
        
        // get the name into 'item ordered'
       // insertWhatDB iwdb= new insertWhatDB(item_orderd);
       
        
        
        
        item_ordered=a.getActionCommand(); 
        query1="select * from `menu_items` where Item_name='"+item_ordered+"'";
      
        //////////////////// perform query to get the item id when we have the items name
        try {
            Statement stmt = db.con.createStatement();
            rs = stmt.executeQuery(query1); 
            while (rs.next()) {
                 ii = rs.getInt("Item_id"); 
            }       
          
        } catch (SQLException ex) { 
               System.err.print("SQLException: ");
               System.err.println(ex.getMessage());
        }            
        
        
        
        
        
        System.out.println(ii);
             
        }
       
    
    
    
    
    
    
    
    
    
    
    
    
    
    private void getButtonText() {          
        try {
            Statement stmt = db.con.createStatement();
            rs = stmt.executeQuery(database_query1); 
            while (rs.next()) {
               String s = rs.getString(name1);   
               db_names[num_items]=s;
               num_items++;
            }       
        } catch (SQLException ex) { 
               System.err.print("SQLException: ");
               System.err.println(ex.getMessage());
        }            
    }
    
    public void addButtons(JPanel panel,int rows, int cols) {
        LayoutManager mgr = new GridLayout(rows,cols);
        panel.setSize(200,300);
        panel.setLayout(mgr);          
        for(int j=0;j<num_items;j++) {   
            JButton comp = new JButton();  
            comp.addActionListener(this);       
            comp.setName(pre_name1+num_items);
            panel.add(comp);               
            comp.setText(db_names[j]);            
            System.out.println("["+j+"]"+db_names[j]);
            
         }    
        
    }
}
