

package items;

import net.rim.device.api.ui.component.*;
import net.rim.device.api.ui.container.*;

import listcallback.*;
import itemtypes.*;

    public class Dessert extends MainScreen {
        private  MainScreen  _infoScreen;
        private ObjectListField myList;
        private int select;
        private int n_items=9;
        private String[] items={"Mozzarella Sticks","Buffalo Wings","Nachos","Potato Skins","French Fries","Onion Rings",
                                "Spinach Dip","Chicken Fingers","Fried Shrimp"};
        private BuyableItem buy_item = new BuyableItem();
        private OrderableItem order_item = new OrderableItem();
        private ViewableItem view_item = new ViewableItem();
        
        public Dessert() 
        {          
            super();            
            setTitle(new LabelField("Dessert Menu", LabelField.ELLIPSIS | LabelField.USE_ALL_WIDTH));
            showListField();            
        }
        
        protected void makeMenu( Menu menu, int instance )
        {
                menu.add(order_item._viewOrderableItem);
                menu.add(buy_item._viewBuyableItem);
                menu.add(view_item._viewableItem);
        }
        
        protected void showListField() 
        {
            ObjectListField myList = new ObjectListField();
            ListCallback myCallback = new ListCallback();
            myList.setCallback(myCallback);
                       
            for(int i=0;i<n_items;i++) {         
                myCallback.add(myList,items[i],i);
            }
            
            add(myList);
            order_item.myList=myList;
            order_item.myCallback=myCallback;
            buy_item.myList=myList;
            buy_item.myCallback=myCallback;
            view_item.myList=myList;
            view_item.myCallback=myCallback;
        }
        
        public void changeMenu(String[] newNames) 
        {
            items=newNames;
            showListField();
        }
} 
    

    




