
package items;

import net.rim.device.api.ui.component.*;
import net.rim.device.api.ui.container.*;

import listcallback.*;
import itemtypes.*;
import listitems.*;

    public class Entrees extends MainScreen {
        private  MainScreen  _infoScreen;
        private ObjectListField myList;
        private int select;
        private int n_items;//=9;
        private String[] items;//={"Chicken Marsala","Chicken Parmesan","Shrimp Fra'Diablo","Filet Mignon","Prime Rib","Fried Flounder",
                               // "Chicken Francaise","Chicken Cordon Bleu","Lobster Tail"};
        private BuyableItem buy_item = new BuyableItem();
        private OrderableItem order_item = new OrderableItem();
        private ViewableItem view_item = new ViewableItem();
        private RemovableItem remove_item = new RemovableItem();
        
        public Entrees() 
        {          
            super();  
            ListItems theList = new ListItems();           
            theList.doQuery("*","menu_items","item_name","Type%20BETWEEN%2090%20AND%2093");
            n_items=theList.num_items;
            items = new String[n_items];
            items=theList.items;    
            setTitle(new LabelField("Entree Menu", LabelField.ELLIPSIS | LabelField.USE_ALL_WIDTH));
            showListField();            
        }
        
        protected void makeMenu( Menu menu, int instance )
        {
                menu.add(order_item._viewOrderableItem);
                menu.add(buy_item._viewBuyableItem);
                menu.add(view_item._viewableItem);
                menu.add(remove_item._viewRemovableItem);
        }
        
        protected void showListField() 
        {
            ObjectListField myList = new ObjectListField();
            ListCallback myCallback = new ListCallback();
            myList.setCallback(myCallback);
                       
            for(int i=0;i<n_items;i++) {         
                myCallback.add(myList,items[i],i);
            }
            
            add(myList);
            order_item.myList=myList;
            order_item.myCallback=myCallback;
            buy_item.myList=myList;
            buy_item.myCallback=myCallback;
            view_item.myList=myList;
            view_item.myCallback=myCallback;
            remove_item.myList=myList;
            remove_item.myCallback=myCallback;
        }
        
        public void changeMenu(String[] newNames) 
        {
            items=newNames;
            showListField();
        }
} 
    

    




