import java.io.*;
import java.util.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import net.rim.device.api.ui.*;
import net.rim.device.api.ui.component.*;
import net.rim.device.api.ui.container.*;
import net.rim.device.api.system.*;
import org.kxml.*;
import org.kxml.parser.*;
import org.kxml.kdom.*;

import listcallback.*;
import support.*;

public class Session {//extends MIDlet implements CommandListener {
  // URL to get session information.
  //private String getURL = "http://68.197.165.187:8000/JWTest/getSession.jsp";
  private static int init;
  private String select = "*";
  private String from = "menu_items";
  private String what = "item_name";
  private String where = "Type=10";
  private String getURL = "http://192.168.44.99:8080/Blackberry/listItems.jsp?select="+select+"&from="+from+"&what="+what+"&where="+where;
  // URL to update session information.
  private String setURL = "http://68.197.165.187:8000/JWTest/updateSession.jsp";

  //private javax.microedition.lcdui.Display display;

  // Three on-screen command buttons.
  private Command cancelCommand;
  private Command doneCommand;
  private Command sendCommand;

  private TextField listField;
  private ListCallback myCallback;
  
  public String[] items;
  
  public Session () {// throws Exception {

    //display = javax.microedition.lcdui.Display.getDisplay(this);
    cancelCommand = new Command("CANCEL", Command.CANCEL, 1);
    doneCommand = new Command("DONE", Command.CANCEL, 1);
    sendCommand = new Command("SEND", Command.SCREEN, 1);

  }  


  public static void main(String[] args) { }
   
  public void startApp() {
    String username=null;
    try {      
      System.out.println("Http Attempt...");
      HttpConnection conn = (HttpConnection)Connector.open( getURL );
      conn.setRequestMethod(HttpConnection.POST);
      conn.setRequestProperty("User-Agent", "Blackberry/3.2.1");

      System.out.println("Input Stream Attempt...");
      InputStream is = conn.openInputStream();
      System.out.println("Parse Attempt...");

      DBXMLParser p;
      p = new DBXMLParser( is );            
      System.out.println("Parsed.");
      System.out.println(p); 
                                      
      System.out.println("count_e: "+p.getRowCount(from));   
      System.out.println("count_l: "+p.getRowCount(what));  
      
      Form form = new Form("Menu List"); 
      myCallback = new ListCallback();       
      //listField = new ObjectListField();
      //listField.setCallback(myCallback);
      //display.setCurrent(form);
      int total=p.getRowCount(from); 
      items=new String[total];          
      for(int i=0;i<total;i++) {      
        username = p.getFieldValue(from, what, i).trim();            
        //myCallback.add(listField,p.getFieldValue(from, what, i).trim(),i);
        listField = new TextField("", username,40, TextField.ANY);
        form.append( listField );
        items[i]=username;
      }
      form.addCommand(cancelCommand);
      form.addCommand(sendCommand);
      form.setCommandListener( (CommandListener) this);     
      // important!
      is.close();      
      conn.close();

    } catch (Exception e) {
      username = "There is an ERROR!";
      
      e.printStackTrace();
    }

      System.out.println(username);
      
      


  }

  /**
   *  Compose an XML string representing a row of data with
   *  a number of fields.
   */
  public static String rowString (String tableName, String[] fieldNames,
                                  String[] fieldValues) throws Exception {

    StringBuffer sb = new StringBuffer();
    // Start tag of the row.
    sb.append("<"+tableName+">");
    for (int i=0; i<fieldNames.length; i++) {
      // Start tag of a field.
      sb.append("<"+fieldNames[i]+">");
      // If the field contains text, write text as
      // the body of the field tag.
      if ( fieldValues[i] != null ) {
        sb.append(fieldValues[i]);
      }
      // Close the field tag.
      sb.append("</"+fieldNames[i]+">");
    }
    // Close the row tag.
    sb.append("</"+tableName+">");
    
    // Output the composed string.
    return sb.toString();
  }
  public void pauseApp() {
  }

  public void destroyApp(boolean unconditional) {
  }

  public void commandAction(Command command, Displayable screen) {
/*
    if (command == cancelCommand) {
      // Do nothing if "CANCEL" is pressed

      destroyApp(false);
      notifyDestroyed();
    } else if (command == doneCommand) {
      // "DONE" is the same as "CANCEL"

      destroyApp(false);
      notifyDestroyed();
    } else if (command == sendCommand) {
      // "SEND" command sends data to the server and displays 
      // response from the server.

      // "status" is displayed after the data is sent.
      // The following message will be over-written 
      // if the update is successful.
      String status = "not defined";

      try {

        // Open a session-aware HTTP connection to the
        // desired JSP page.
        HttpConnection conn = SessionConnector.open( setURL );
        conn.setRequestMethod(HttpConnection.POST);

        // Get the new username from the TextField box.
        //username = listField.getSelection();
        String tableName = "SessionInfo";
        String [] fieldNames = {"Username"};
        String [] fieldValues = {username};
        // And assemble it into an XML document to be sent to the server.
        String post = "<root>" + 
                    DBXMLParser.rowString(tableName, fieldNames, fieldValues) +
                      "</root>\n";

        // Send the XML document containing username info to the 
        // server through a HTTP .
        DataOutputStream os = conn.openDataOutputStream();
        os.write(post.getBytes());
        os.flush();
        os.close();

        // Get the response from the JSP page.
        DataInputStream is = conn.openDataInputStream();
        DBXMLParser p = new DBXMLParser( is );
        // Get the status and over-write the "not defined" value.
        status = p.getFieldValue("Response", "Status", 0);
        is.close();

        // important!
        conn.close();

      } catch (Exception e) {
        status = "failed";
        e.printStackTrace();
      }
      if(status==null) System.out.println("status is null");
      // Display new username in the TexField with command buttons.
      Form form = new Form("Results");    
      StringItem sItem;
      sItem  = new StringItem("Status", status.trim() );
      form.append( sItem );
      form.addCommand(doneCommand);
      form.setCommandListener( (CommandListener) this);
      display.setCurrent(form);
    }
    */
  } 
}
