/*
 * BartenderGUI.java
 *
 * Created on April 9, 2007, 10:19 PM
 */

package BartenderUI;
import java.awt.event.*;
import javax.swing.*;
import callserver.*;

// importing the package startbuttons
import startbuttons.*;


/**
 *
 * @author  Albert
 */
public class BartenderGUI extends javax.swing.JApplet {
    
   
    private float num;
    private DefaultListModel td_model;
    private String list_item_name="22";
    private CreateButtons cb;
    private TabButtons tb;
    private CallServer notifier;
    
    
    
    /**
     * Initializes the applet BartenderGUI
     */
    public void init() {
        try {
            java.awt.EventQueue.invokeAndWait(new Runnable() {
                public void run() {
                    initComponents();
                }
            });
            
        } catch (Exception ex) {
            ex.printStackTrace();           
        }
        
        td_model=new DefaultListModel();
        
        TabDetailsList.setModel(td_model);
        notifier=new CallServer();
        
        
            
            
        
         
        // Declare variables used in this class 
        String database_query1;
        String pre_name1;
        String name1;        
                
                
        // What we want to use to name the buttons
        name1="Item_name";
        num=0;
        
        //////////////////////////////////////////////////////////////////////////////////////
        this.setSize(900,700);
        // Bottled beer = 00
        database_query1="SELECT * FROM menu_items WHERE Type = 00";
        pre_name1="bbeer";
        cb= new CreateButtons(BottledBeerPanel,database_query1,pre_name1,name1,5,5,TabTotalDisplay,td_model);
        
        // Draft beer = 10
        database_query1="SELECT * FROM menu_items WHERE Type = 10";
        pre_name1="dbeer";
        cb.addButtons(DraftBeerPanel,database_query1,pre_name1,name1,5,5);
        //cb =  new CreateButtons(DraftBeerPanel,database_query1,pre_name1,name1,5,5,TabTotalDisplay,td_model);
        
        // Cocktails = 20
        database_query1="SELECT * FROM menu_items WHERE Type = 20";
        pre_name1="cocktail";
        cb.addButtons(CocktailsPanel,database_query1,pre_name1,name1,5,5);
        
        // Liquor = 30
        database_query1="SELECT * FROM menu_items WHERE Type = 30";
        pre_name1="liquor";
        cb.addButtons(LiquorPanel,database_query1,pre_name1,name1,5,5);
        
        // Softdrinks = 40
        database_query1="SELECT * FROM menu_items WHERE Type = 40";
        pre_name1="soft";
        cb.addButtons(SoftDrinksPanel,database_query1,pre_name1,name1,5,5);
        
        // Hotdinks = 50
        database_query1="SELECT * FROM menu_items WHERE Type = 50";
        pre_name1="hot";
        cb.addButtons(HotDrinksPanel,database_query1,pre_name1,name1,5,5);   
        
        // Apperizers = 60
        database_query1="SELECT * FROM menu_items WHERE Type = 60";
        pre_name1="apps";
        cb.addButtons(AppetizersPanel,database_query1,pre_name1,name1,5,5);
        
        //Breakfast = 70
        database_query1="SELECT * FROM menu_items WHERE Type = 70";
        pre_name1="break";
        cb.addButtons(BreakfastPanel,database_query1,pre_name1,name1,5,5);
        
        // LunchOther = 80
        database_query1="SELECT * FROM menu_items WHERE Type = 80";
        pre_name1="luncho";
        cb.addButtons(LunchOtherPanel,database_query1,pre_name1,name1,5,5);
        
        //LunchChicken = 81
        database_query1="SELECT * FROM menu_items WHERE Type = 81";
        pre_name1="lunchc";
        cb.addButtons(LunchChickenPanel,database_query1,pre_name1,name1,5,5);
        
        // LunchSteak = 82
        database_query1="SELECT * FROM menu_items WHERE Type = 82";
        pre_name1="lunchs";
        cb.addButtons(LunchSteakPanel,database_query1,pre_name1,name1,5,5);
        
        // LunchFish = 83
        database_query1="SELECT * FROM menu_items WHERE Type = 83";
        pre_name1="lunchf";
        cb.addButtons(LunchFishPanel,database_query1,pre_name1,name1,5,5);
        
        // DinnerOther = 90
        database_query1="SELECT * FROM menu_items WHERE Type = 90";
        pre_name1="dinnero";
        cb.addButtons(DinnerOtherPanel,database_query1,pre_name1,name1,5,5);
        
        // DinnerChicken = 91
        database_query1="SELECT * FROM menu_items WHERE Type = 91";
        pre_name1="dinnerc";
        cb.addButtons(DinnerChickenPanel,database_query1,pre_name1,name1,5,5);
        
        //DinnerSteak = 92
        database_query1="SELECT * FROM menu_items WHERE Type = 92";
        pre_name1="dinners";
        cb.addButtons(DinnerSteakPanel,database_query1,pre_name1,name1,5,5);
        
        // dinner fish = 93
        database_query1="SELECT * FROM menu_items WHERE Type = 93";
        pre_name1="dinnerf";
        cb.addButtons(DinnerFishPanel,database_query1,pre_name1,name1,5,5);
        
        // desserts = 100
        database_query1="SELECT * FROM menu_items WHERE Type = 100";
        pre_name1="dessert";
        cb.addButtons(DessertsPanel,database_query1,pre_name1,name1,5,5);
        
        
        // Generate Active Tabs Panel 
        database_query1="select * from `active_orders` where Item_name='-';";
        tb=new TabButtons(TabsPanel,database_query1,"Tab","Order_id",10,1,td_model);
        
    }
    
  
    
    
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        SwitchUserButton = new javax.swing.JButton();
        LogOutButton = new javax.swing.JButton();
        OrderingPanel = new javax.swing.JPanel();
        TabsListLabel = new javax.swing.JLabel();
        OrderingTabbedPane = new javax.swing.JTabbedPane();
        DrinksSpecialsTab = new javax.swing.JPanel();
        DrinksSpecialsPanel = new javax.swing.JPanel();
        DraftBeerTab = new javax.swing.JPanel();
        DraftBeerPanel = new javax.swing.JPanel();
        BottledBeerTab = new javax.swing.JPanel();
        BottledBeerPanel = new javax.swing.JPanel();
        CocktailsTab = new javax.swing.JPanel();
        CocktailsPanel = new javax.swing.JPanel();
        LiquorTab = new javax.swing.JPanel();
        LiquorPanel = new javax.swing.JPanel();
        BreakfastTab = new javax.swing.JPanel();
        BreakfastPanel = new javax.swing.JPanel();
        LunchTab = new javax.swing.JPanel();
        LunchTabbedPane = new javax.swing.JTabbedPane();
        LunchSpecialsTab = new javax.swing.JPanel();
        LunchSpecialsPanel = new javax.swing.JPanel();
        LunchChickenTab = new javax.swing.JPanel();
        LunchChickenPanel = new javax.swing.JPanel();
        LunchFishTab = new javax.swing.JPanel();
        LunchFishPanel = new javax.swing.JPanel();
        LunchSteakTab = new javax.swing.JPanel();
        LunchSteakPanel = new javax.swing.JPanel();
        LunchOtherTab = new javax.swing.JPanel();
        LunchOtherPanel = new javax.swing.JPanel();
        SoftDrinksTab = new javax.swing.JPanel();
        SoftDrinksPanel = new javax.swing.JPanel();
        HotDrinksTab = new javax.swing.JPanel();
        HotDrinksPanel = new javax.swing.JPanel();
        DinnerTab = new javax.swing.JPanel();
        DinnerPanel = new javax.swing.JPanel();
        DinnerTabbedPane = new javax.swing.JTabbedPane();
        DinnerSpecialsTab = new javax.swing.JPanel();
        DinnerSpecialsPanel = new javax.swing.JPanel();
        DinnerChickenTab = new javax.swing.JPanel();
        DinnerChickenPanel = new javax.swing.JPanel();
        DinnerFishTab = new javax.swing.JPanel();
        DinnerFishPanel = new javax.swing.JPanel();
        DinnerSteakTab = new javax.swing.JPanel();
        DinnerSteakPanel = new javax.swing.JPanel();
        DinnerOtherTab = new javax.swing.JPanel();
        DinnerOtherPanel = new javax.swing.JPanel();
        AppetizersTab = new javax.swing.JPanel();
        AppetizersPanel = new javax.swing.JPanel();
        DessertsTab = new javax.swing.JPanel();
        DessertsPanel = new javax.swing.JPanel();
        OrderReadyButton = new javax.swing.JButton();
        OpenTabButton = new javax.swing.JButton();
        TabDetailsScrollPane = new javax.swing.JScrollPane();
        TabDetailsList = new javax.swing.JList();
        TabTotalLabel = new javax.swing.JLabel();
        CloseTabButton = new javax.swing.JButton();
        TabDetailsLabel = new javax.swing.JLabel();
        TablesOrdersListLabel = new javax.swing.JLabel();
        TabTotalDisplay = new javax.swing.JTextField();
        TabsPanel = new javax.swing.JPanel();
        viewTab = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        EmployeeNameLabel = new javax.swing.JLabel();
        EmployeeNameTextField = new javax.swing.JTextField();
        EmployeeTypeTextField = new javax.swing.JTextField();

        SwitchUserButton.setFont(new java.awt.Font("Tahoma", 1, 12));
        SwitchUserButton.setText("Switch User");

        LogOutButton.setFont(new java.awt.Font("Tahoma", 1, 12));
        LogOutButton.setText("Log Out");

        TabsListLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        TabsListLabel.setText("Tabs List:");

        OrderingTabbedPane.setFont(new java.awt.Font("Tahoma", 1, 12));
        javax.swing.GroupLayout DrinksSpecialsPanelLayout = new javax.swing.GroupLayout(DrinksSpecialsPanel);
        DrinksSpecialsPanel.setLayout(DrinksSpecialsPanelLayout);
        DrinksSpecialsPanelLayout.setHorizontalGroup(
            DrinksSpecialsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 411, Short.MAX_VALUE)
        );
        DrinksSpecialsPanelLayout.setVerticalGroup(
            DrinksSpecialsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 402, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout DrinksSpecialsTabLayout = new javax.swing.GroupLayout(DrinksSpecialsTab);
        DrinksSpecialsTab.setLayout(DrinksSpecialsTabLayout);
        DrinksSpecialsTabLayout.setHorizontalGroup(
            DrinksSpecialsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DrinksSpecialsTabLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(DrinksSpecialsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(143, Short.MAX_VALUE))
        );
        DrinksSpecialsTabLayout.setVerticalGroup(
            DrinksSpecialsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DrinksSpecialsTabLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(DrinksSpecialsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        OrderingTabbedPane.addTab("Drinks Specials", DrinksSpecialsTab);

        javax.swing.GroupLayout DraftBeerPanelLayout = new javax.swing.GroupLayout(DraftBeerPanel);
        DraftBeerPanel.setLayout(DraftBeerPanelLayout);
        DraftBeerPanelLayout.setHorizontalGroup(
            DraftBeerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 554, Short.MAX_VALUE)
        );
        DraftBeerPanelLayout.setVerticalGroup(
            DraftBeerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 424, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout DraftBeerTabLayout = new javax.swing.GroupLayout(DraftBeerTab);
        DraftBeerTab.setLayout(DraftBeerTabLayout);
        DraftBeerTabLayout.setHorizontalGroup(
            DraftBeerTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DraftBeerTabLayout.createSequentialGroup()
                .addComponent(DraftBeerPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        DraftBeerTabLayout.setVerticalGroup(
            DraftBeerTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DraftBeerPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Draft Beer", DraftBeerTab);

        javax.swing.GroupLayout BottledBeerPanelLayout = new javax.swing.GroupLayout(BottledBeerPanel);
        BottledBeerPanel.setLayout(BottledBeerPanelLayout);
        BottledBeerPanelLayout.setHorizontalGroup(
            BottledBeerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 564, Short.MAX_VALUE)
        );
        BottledBeerPanelLayout.setVerticalGroup(
            BottledBeerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 424, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout BottledBeerTabLayout = new javax.swing.GroupLayout(BottledBeerTab);
        BottledBeerTab.setLayout(BottledBeerTabLayout);
        BottledBeerTabLayout.setHorizontalGroup(
            BottledBeerTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(BottledBeerPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        BottledBeerTabLayout.setVerticalGroup(
            BottledBeerTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(BottledBeerPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Bottled Beer", BottledBeerTab);

        javax.swing.GroupLayout CocktailsPanelLayout = new javax.swing.GroupLayout(CocktailsPanel);
        CocktailsPanel.setLayout(CocktailsPanelLayout);
        CocktailsPanelLayout.setHorizontalGroup(
            CocktailsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 564, Short.MAX_VALUE)
        );
        CocktailsPanelLayout.setVerticalGroup(
            CocktailsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 424, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout CocktailsTabLayout = new javax.swing.GroupLayout(CocktailsTab);
        CocktailsTab.setLayout(CocktailsTabLayout);
        CocktailsTabLayout.setHorizontalGroup(
            CocktailsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(CocktailsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        CocktailsTabLayout.setVerticalGroup(
            CocktailsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(CocktailsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Cocktails", CocktailsTab);

        javax.swing.GroupLayout LiquorPanelLayout = new javax.swing.GroupLayout(LiquorPanel);
        LiquorPanel.setLayout(LiquorPanelLayout);
        LiquorPanelLayout.setHorizontalGroup(
            LiquorPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 564, Short.MAX_VALUE)
        );
        LiquorPanelLayout.setVerticalGroup(
            LiquorPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 424, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout LiquorTabLayout = new javax.swing.GroupLayout(LiquorTab);
        LiquorTab.setLayout(LiquorTabLayout);
        LiquorTabLayout.setHorizontalGroup(
            LiquorTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LiquorPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LiquorTabLayout.setVerticalGroup(
            LiquorTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LiquorPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Liquor", LiquorTab);

        javax.swing.GroupLayout BreakfastPanelLayout = new javax.swing.GroupLayout(BreakfastPanel);
        BreakfastPanel.setLayout(BreakfastPanelLayout);
        BreakfastPanelLayout.setHorizontalGroup(
            BreakfastPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 266, Short.MAX_VALUE)
        );
        BreakfastPanelLayout.setVerticalGroup(
            BreakfastPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 413, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout BreakfastTabLayout = new javax.swing.GroupLayout(BreakfastTab);
        BreakfastTab.setLayout(BreakfastTabLayout);
        BreakfastTabLayout.setHorizontalGroup(
            BreakfastTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(BreakfastTabLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(BreakfastPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(288, 288, 288))
        );
        BreakfastTabLayout.setVerticalGroup(
            BreakfastTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, BreakfastTabLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(BreakfastPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        OrderingTabbedPane.addTab("Breakfast", BreakfastTab);

        LunchTabbedPane.setFont(new java.awt.Font("Tahoma", 1, 12));
        javax.swing.GroupLayout LunchSpecialsPanelLayout = new javax.swing.GroupLayout(LunchSpecialsPanel);
        LunchSpecialsPanel.setLayout(LunchSpecialsPanelLayout);
        LunchSpecialsPanelLayout.setHorizontalGroup(
            LunchSpecialsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 500, Short.MAX_VALUE)
        );
        LunchSpecialsPanelLayout.setVerticalGroup(
            LunchSpecialsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 541, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout LunchSpecialsTabLayout = new javax.swing.GroupLayout(LunchSpecialsTab);
        LunchSpecialsTab.setLayout(LunchSpecialsTabLayout);
        LunchSpecialsTabLayout.setHorizontalGroup(
            LunchSpecialsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, LunchSpecialsTabLayout.createSequentialGroup()
                .addContainerGap(59, Short.MAX_VALUE)
                .addComponent(LunchSpecialsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        LunchSpecialsTabLayout.setVerticalGroup(
            LunchSpecialsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, LunchSpecialsTabLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(LunchSpecialsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        LunchTabbedPane.addTab("Specials", LunchSpecialsTab);

        javax.swing.GroupLayout LunchChickenPanelLayout = new javax.swing.GroupLayout(LunchChickenPanel);
        LunchChickenPanel.setLayout(LunchChickenPanelLayout);
        LunchChickenPanelLayout.setHorizontalGroup(
            LunchChickenPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 559, Short.MAX_VALUE)
        );
        LunchChickenPanelLayout.setVerticalGroup(
            LunchChickenPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 398, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout LunchChickenTabLayout = new javax.swing.GroupLayout(LunchChickenTab);
        LunchChickenTab.setLayout(LunchChickenTabLayout);
        LunchChickenTabLayout.setHorizontalGroup(
            LunchChickenTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LunchChickenPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchChickenTabLayout.setVerticalGroup(
            LunchChickenTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LunchChickenPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchTabbedPane.addTab("Chicken", LunchChickenTab);

        javax.swing.GroupLayout LunchFishPanelLayout = new javax.swing.GroupLayout(LunchFishPanel);
        LunchFishPanel.setLayout(LunchFishPanelLayout);
        LunchFishPanelLayout.setHorizontalGroup(
            LunchFishPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 559, Short.MAX_VALUE)
        );
        LunchFishPanelLayout.setVerticalGroup(
            LunchFishPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 398, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout LunchFishTabLayout = new javax.swing.GroupLayout(LunchFishTab);
        LunchFishTab.setLayout(LunchFishTabLayout);
        LunchFishTabLayout.setHorizontalGroup(
            LunchFishTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LunchFishPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchFishTabLayout.setVerticalGroup(
            LunchFishTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LunchFishPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchTabbedPane.addTab("Fish", LunchFishTab);

        javax.swing.GroupLayout LunchSteakPanelLayout = new javax.swing.GroupLayout(LunchSteakPanel);
        LunchSteakPanel.setLayout(LunchSteakPanelLayout);
        LunchSteakPanelLayout.setHorizontalGroup(
            LunchSteakPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 559, Short.MAX_VALUE)
        );
        LunchSteakPanelLayout.setVerticalGroup(
            LunchSteakPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 398, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout LunchSteakTabLayout = new javax.swing.GroupLayout(LunchSteakTab);
        LunchSteakTab.setLayout(LunchSteakTabLayout);
        LunchSteakTabLayout.setHorizontalGroup(
            LunchSteakTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LunchSteakPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchSteakTabLayout.setVerticalGroup(
            LunchSteakTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LunchSteakPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchTabbedPane.addTab("Steak", LunchSteakTab);

        LunchOtherTab.setFont(new java.awt.Font("Tahoma", 1, 12));
        javax.swing.GroupLayout LunchOtherPanelLayout = new javax.swing.GroupLayout(LunchOtherPanel);
        LunchOtherPanel.setLayout(LunchOtherPanelLayout);
        LunchOtherPanelLayout.setHorizontalGroup(
            LunchOtherPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 559, Short.MAX_VALUE)
        );
        LunchOtherPanelLayout.setVerticalGroup(
            LunchOtherPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 398, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout LunchOtherTabLayout = new javax.swing.GroupLayout(LunchOtherTab);
        LunchOtherTab.setLayout(LunchOtherTabLayout);
        LunchOtherTabLayout.setHorizontalGroup(
            LunchOtherTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LunchOtherPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchOtherTabLayout.setVerticalGroup(
            LunchOtherTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LunchOtherPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchTabbedPane.addTab("Other", LunchOtherTab);

        javax.swing.GroupLayout LunchTabLayout = new javax.swing.GroupLayout(LunchTab);
        LunchTab.setLayout(LunchTabLayout);
        LunchTabLayout.setHorizontalGroup(
            LunchTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LunchTabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 564, Short.MAX_VALUE)
        );
        LunchTabLayout.setVerticalGroup(
            LunchTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(LunchTabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 424, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Lunch", LunchTab);

        javax.swing.GroupLayout SoftDrinksPanelLayout = new javax.swing.GroupLayout(SoftDrinksPanel);
        SoftDrinksPanel.setLayout(SoftDrinksPanelLayout);
        SoftDrinksPanelLayout.setHorizontalGroup(
            SoftDrinksPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 564, Short.MAX_VALUE)
        );
        SoftDrinksPanelLayout.setVerticalGroup(
            SoftDrinksPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 424, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout SoftDrinksTabLayout = new javax.swing.GroupLayout(SoftDrinksTab);
        SoftDrinksTab.setLayout(SoftDrinksTabLayout);
        SoftDrinksTabLayout.setHorizontalGroup(
            SoftDrinksTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(SoftDrinksPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        SoftDrinksTabLayout.setVerticalGroup(
            SoftDrinksTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(SoftDrinksPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Soft Drinks", SoftDrinksTab);

        javax.swing.GroupLayout HotDrinksPanelLayout = new javax.swing.GroupLayout(HotDrinksPanel);
        HotDrinksPanel.setLayout(HotDrinksPanelLayout);
        HotDrinksPanelLayout.setHorizontalGroup(
            HotDrinksPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 564, Short.MAX_VALUE)
        );
        HotDrinksPanelLayout.setVerticalGroup(
            HotDrinksPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 424, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout HotDrinksTabLayout = new javax.swing.GroupLayout(HotDrinksTab);
        HotDrinksTab.setLayout(HotDrinksTabLayout);
        HotDrinksTabLayout.setHorizontalGroup(
            HotDrinksTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(HotDrinksPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        HotDrinksTabLayout.setVerticalGroup(
            HotDrinksTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(HotDrinksPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Hot Drinks", HotDrinksTab);

        DinnerTabbedPane.setFont(new java.awt.Font("Tahoma", 1, 12));
        javax.swing.GroupLayout DinnerSpecialsPanelLayout = new javax.swing.GroupLayout(DinnerSpecialsPanel);
        DinnerSpecialsPanel.setLayout(DinnerSpecialsPanelLayout);
        DinnerSpecialsPanelLayout.setHorizontalGroup(
            DinnerSpecialsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 559, Short.MAX_VALUE)
        );
        DinnerSpecialsPanelLayout.setVerticalGroup(
            DinnerSpecialsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 533, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout DinnerSpecialsTabLayout = new javax.swing.GroupLayout(DinnerSpecialsTab);
        DinnerSpecialsTab.setLayout(DinnerSpecialsTabLayout);
        DinnerSpecialsTabLayout.setHorizontalGroup(
            DinnerSpecialsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DinnerSpecialsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerSpecialsTabLayout.setVerticalGroup(
            DinnerSpecialsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DinnerSpecialsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerTabbedPane.addTab("Specials", DinnerSpecialsTab);

        javax.swing.GroupLayout DinnerChickenPanelLayout = new javax.swing.GroupLayout(DinnerChickenPanel);
        DinnerChickenPanel.setLayout(DinnerChickenPanelLayout);
        DinnerChickenPanelLayout.setHorizontalGroup(
            DinnerChickenPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 559, Short.MAX_VALUE)
        );
        DinnerChickenPanelLayout.setVerticalGroup(
            DinnerChickenPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 533, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout DinnerChickenTabLayout = new javax.swing.GroupLayout(DinnerChickenTab);
        DinnerChickenTab.setLayout(DinnerChickenTabLayout);
        DinnerChickenTabLayout.setHorizontalGroup(
            DinnerChickenTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DinnerChickenPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerChickenTabLayout.setVerticalGroup(
            DinnerChickenTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DinnerChickenPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerTabbedPane.addTab("Chicken", DinnerChickenTab);

        javax.swing.GroupLayout DinnerFishPanelLayout = new javax.swing.GroupLayout(DinnerFishPanel);
        DinnerFishPanel.setLayout(DinnerFishPanelLayout);
        DinnerFishPanelLayout.setHorizontalGroup(
            DinnerFishPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 559, Short.MAX_VALUE)
        );
        DinnerFishPanelLayout.setVerticalGroup(
            DinnerFishPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 533, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout DinnerFishTabLayout = new javax.swing.GroupLayout(DinnerFishTab);
        DinnerFishTab.setLayout(DinnerFishTabLayout);
        DinnerFishTabLayout.setHorizontalGroup(
            DinnerFishTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DinnerFishPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerFishTabLayout.setVerticalGroup(
            DinnerFishTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DinnerFishPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerTabbedPane.addTab("Fish", DinnerFishTab);

        javax.swing.GroupLayout DinnerSteakPanelLayout = new javax.swing.GroupLayout(DinnerSteakPanel);
        DinnerSteakPanel.setLayout(DinnerSteakPanelLayout);
        DinnerSteakPanelLayout.setHorizontalGroup(
            DinnerSteakPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 559, Short.MAX_VALUE)
        );
        DinnerSteakPanelLayout.setVerticalGroup(
            DinnerSteakPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 522, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout DinnerSteakTabLayout = new javax.swing.GroupLayout(DinnerSteakTab);
        DinnerSteakTab.setLayout(DinnerSteakTabLayout);
        DinnerSteakTabLayout.setHorizontalGroup(
            DinnerSteakTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DinnerSteakPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerSteakTabLayout.setVerticalGroup(
            DinnerSteakTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DinnerSteakTabLayout.createSequentialGroup()
                .addComponent(DinnerSteakPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        DinnerTabbedPane.addTab("Steak", DinnerSteakTab);

        DinnerOtherTab.setFont(new java.awt.Font("Tahoma", 1, 12));
        javax.swing.GroupLayout DinnerOtherPanelLayout = new javax.swing.GroupLayout(DinnerOtherPanel);
        DinnerOtherPanel.setLayout(DinnerOtherPanelLayout);
        DinnerOtherPanelLayout.setHorizontalGroup(
            DinnerOtherPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 559, Short.MAX_VALUE)
        );
        DinnerOtherPanelLayout.setVerticalGroup(
            DinnerOtherPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 522, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout DinnerOtherTabLayout = new javax.swing.GroupLayout(DinnerOtherTab);
        DinnerOtherTab.setLayout(DinnerOtherTabLayout);
        DinnerOtherTabLayout.setHorizontalGroup(
            DinnerOtherTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DinnerOtherPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerOtherTabLayout.setVerticalGroup(
            DinnerOtherTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DinnerOtherTabLayout.createSequentialGroup()
                .addComponent(DinnerOtherPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        DinnerTabbedPane.addTab("Other", DinnerOtherTab);

        javax.swing.GroupLayout DinnerPanelLayout = new javax.swing.GroupLayout(DinnerPanel);
        DinnerPanel.setLayout(DinnerPanelLayout);
        DinnerPanelLayout.setHorizontalGroup(
            DinnerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DinnerTabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 564, Short.MAX_VALUE)
        );
        DinnerPanelLayout.setVerticalGroup(
            DinnerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DinnerTabbedPane, javax.swing.GroupLayout.PREFERRED_SIZE, 559, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        javax.swing.GroupLayout DinnerTabLayout = new javax.swing.GroupLayout(DinnerTab);
        DinnerTab.setLayout(DinnerTabLayout);
        DinnerTabLayout.setHorizontalGroup(
            DinnerTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DinnerPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerTabLayout.setVerticalGroup(
            DinnerTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DinnerTabLayout.createSequentialGroup()
                .addComponent(DinnerPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        OrderingTabbedPane.addTab("Dinner", DinnerTab);

        javax.swing.GroupLayout AppetizersPanelLayout = new javax.swing.GroupLayout(AppetizersPanel);
        AppetizersPanel.setLayout(AppetizersPanelLayout);
        AppetizersPanelLayout.setHorizontalGroup(
            AppetizersPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 564, Short.MAX_VALUE)
        );
        AppetizersPanelLayout.setVerticalGroup(
            AppetizersPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 424, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout AppetizersTabLayout = new javax.swing.GroupLayout(AppetizersTab);
        AppetizersTab.setLayout(AppetizersTabLayout);
        AppetizersTabLayout.setHorizontalGroup(
            AppetizersTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(AppetizersPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        AppetizersTabLayout.setVerticalGroup(
            AppetizersTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(AppetizersPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Appetizers", AppetizersTab);

        javax.swing.GroupLayout DessertsPanelLayout = new javax.swing.GroupLayout(DessertsPanel);
        DessertsPanel.setLayout(DessertsPanelLayout);
        DessertsPanelLayout.setHorizontalGroup(
            DessertsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 564, Short.MAX_VALUE)
        );
        DessertsPanelLayout.setVerticalGroup(
            DessertsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 424, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout DessertsTabLayout = new javax.swing.GroupLayout(DessertsTab);
        DessertsTab.setLayout(DessertsTabLayout);
        DessertsTabLayout.setHorizontalGroup(
            DessertsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DessertsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DessertsTabLayout.setVerticalGroup(
            DessertsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(DessertsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Desserts", DessertsTab);

        OrderReadyButton.setFont(new java.awt.Font("Tahoma", 1, 12));
        OrderReadyButton.setText("Order Ready");
        OrderReadyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrderReadyButtonActionPerformed(evt);
            }
        });

        OpenTabButton.setFont(new java.awt.Font("Tahoma", 1, 12));
        OpenTabButton.setText("Add to Tab");
        OpenTabButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OpenTabButtonActionPerformed(evt);
            }
        });

        TabDetailsList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        TabDetailsList.setMinimumSize(new java.awt.Dimension(100, 200));
        TabDetailsList.setPreferredSize(new java.awt.Dimension(250, 300));
        TabDetailsScrollPane.setViewportView(TabDetailsList);

        TabTotalLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        TabTotalLabel.setText("Tab Total:");

        CloseTabButton.setFont(new java.awt.Font("Tahoma", 1, 12));
        CloseTabButton.setText("Close Tab");
        CloseTabButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CloseTabButtonActionPerformed(evt);
            }
        });

        TabDetailsLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        TabDetailsLabel.setText("Tab Details:");

        TablesOrdersListLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        TablesOrdersListLabel.setText("Tables Orders List:");

        javax.swing.GroupLayout TabsPanelLayout = new javax.swing.GroupLayout(TabsPanel);
        TabsPanel.setLayout(TabsPanelLayout);
        TabsPanelLayout.setHorizontalGroup(
            TabsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 112, Short.MAX_VALUE)
        );
        TabsPanelLayout.setVerticalGroup(
            TabsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 142, Short.MAX_VALUE)
        );

        viewTab.setText("View Tab");
        viewTab.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewTabActionPerformed(evt);
            }
        });

        jButton1.setText("Exit Tab");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 112, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 246, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout OrderingPanelLayout = new javax.swing.GroupLayout(OrderingPanel);
        OrderingPanel.setLayout(OrderingPanelLayout);
        OrderingPanelLayout.setHorizontalGroup(
            OrderingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(OrderingPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(OrderingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(OrderingPanelLayout.createSequentialGroup()
                        .addGroup(OrderingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(TabsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(TablesOrdersListLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(OrderReadyButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(32, 32, 32)
                        .addComponent(OrderingTabbedPane, javax.swing.GroupLayout.PREFERRED_SIZE, 569, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 26, Short.MAX_VALUE)
                        .addGroup(OrderingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(OrderingPanelLayout.createSequentialGroup()
                                .addGroup(OrderingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(viewTab, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(OpenTabButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(CloseTabButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(TabDetailsLabel)
                            .addComponent(TabTotalDisplay, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(TabTotalLabel)
                            .addComponent(TabDetailsScrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(206, 206, 206))
                    .addGroup(OrderingPanelLayout.createSequentialGroup()
                        .addComponent(TabsListLabel)
                        .addContainerGap(1147, Short.MAX_VALUE))))
        );
        OrderingPanelLayout.setVerticalGroup(
            OrderingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, OrderingPanelLayout.createSequentialGroup()
                .addGroup(OrderingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, OrderingPanelLayout.createSequentialGroup()
                        .addGap(19, 19, 19)
                        .addComponent(CloseTabButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(OpenTabButton)
                        .addGap(7, 7, 7)
                        .addGroup(OrderingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(viewTab)
                            .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(TabDetailsLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(TabDetailsScrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, 305, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 18, Short.MAX_VALUE)
                        .addComponent(TabTotalLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(TabTotalDisplay, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(OrderingPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(TabsListLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(OrderingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(OrderingTabbedPane, 0, 0, Short.MAX_VALUE)
                            .addGroup(OrderingPanelLayout.createSequentialGroup()
                                .addComponent(TabsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(17, 17, 17)
                                .addComponent(TablesOrdersListLabel)
                                .addGap(15, 15, 15)
                                .addComponent(OrderReadyButton)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addGap(187, 187, 187))
        );

        EmployeeNameLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        EmployeeNameLabel.setText("Employee Name:");

        EmployeeNameTextField.setFont(new java.awt.Font("Tahoma", 1, 12));
        EmployeeNameTextField.setText("Bryan Rabin");

        EmployeeTypeTextField.setFont(new java.awt.Font("Tahoma", 1, 12));
        EmployeeTypeTextField.setText("Bartender");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(26, Short.MAX_VALUE)
                .addComponent(SwitchUserButton)
                .addGap(14, 14, 14)
                .addComponent(LogOutButton)
                .addGap(82, 82, 82)
                .addComponent(EmployeeTypeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 112, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(EmployeeNameLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(EmployeeNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(866, 866, 866))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(OrderingPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(306, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(SwitchUserButton)
                    .addComponent(LogOutButton)
                    .addComponent(EmployeeNameLabel)
                    .addComponent(EmployeeNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(EmployeeTypeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(OrderingPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(19, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void OrderReadyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OrderReadyButtonActionPerformed
        notifier.sendMessage();
    }//GEN-LAST:event_OrderReadyButtonActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
      td_model.clear();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void viewTabActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewTabActionPerformed
        
        String order_id=tb.getOrderId();
        //TabDetailsList.
        System.out.println(order_id);      
        tb.viewTab(order_id);
        
        
        
        
    }//GEN-LAST:event_viewTabActionPerformed

    private void OpenTabButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OpenTabButtonActionPerformed
        
        cb.enterItems();
        td_model.clear();
        TabDetailsList.setModel(td_model);
    }//GEN-LAST:event_OpenTabButtonActionPerformed

    private void CloseTabButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CloseTabButtonActionPerformed
        String order_id=tb.getOrderId();
        tb.closeTab(order_id);
  
    }//GEN-LAST:event_CloseTabButtonActionPerformed
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel AppetizersPanel;
    private javax.swing.JPanel AppetizersTab;
    private javax.swing.JPanel BottledBeerPanel;
    private javax.swing.JPanel BottledBeerTab;
    private javax.swing.JPanel BreakfastPanel;
    private javax.swing.JPanel BreakfastTab;
    private javax.swing.JButton CloseTabButton;
    private javax.swing.JPanel CocktailsPanel;
    private javax.swing.JPanel CocktailsTab;
    private javax.swing.JPanel DessertsPanel;
    private javax.swing.JPanel DessertsTab;
    private javax.swing.JPanel DinnerChickenPanel;
    private javax.swing.JPanel DinnerChickenTab;
    private javax.swing.JPanel DinnerFishPanel;
    private javax.swing.JPanel DinnerFishTab;
    private javax.swing.JPanel DinnerOtherPanel;
    private javax.swing.JPanel DinnerOtherTab;
    private javax.swing.JPanel DinnerPanel;
    private javax.swing.JPanel DinnerSpecialsPanel;
    private javax.swing.JPanel DinnerSpecialsTab;
    private javax.swing.JPanel DinnerSteakPanel;
    private javax.swing.JPanel DinnerSteakTab;
    private javax.swing.JPanel DinnerTab;
    private javax.swing.JTabbedPane DinnerTabbedPane;
    private javax.swing.JPanel DraftBeerPanel;
    private javax.swing.JPanel DraftBeerTab;
    private javax.swing.JPanel DrinksSpecialsPanel;
    private javax.swing.JPanel DrinksSpecialsTab;
    private javax.swing.JLabel EmployeeNameLabel;
    private javax.swing.JTextField EmployeeNameTextField;
    private javax.swing.JTextField EmployeeTypeTextField;
    private javax.swing.JPanel HotDrinksPanel;
    private javax.swing.JPanel HotDrinksTab;
    private javax.swing.JPanel LiquorPanel;
    private javax.swing.JPanel LiquorTab;
    private javax.swing.JButton LogOutButton;
    private javax.swing.JPanel LunchChickenPanel;
    private javax.swing.JPanel LunchChickenTab;
    private javax.swing.JPanel LunchFishPanel;
    private javax.swing.JPanel LunchFishTab;
    private javax.swing.JPanel LunchOtherPanel;
    private javax.swing.JPanel LunchOtherTab;
    private javax.swing.JPanel LunchSpecialsPanel;
    private javax.swing.JPanel LunchSpecialsTab;
    private javax.swing.JPanel LunchSteakPanel;
    private javax.swing.JPanel LunchSteakTab;
    private javax.swing.JPanel LunchTab;
    private javax.swing.JTabbedPane LunchTabbedPane;
    private javax.swing.JButton OpenTabButton;
    private javax.swing.JButton OrderReadyButton;
    private javax.swing.JPanel OrderingPanel;
    private javax.swing.JTabbedPane OrderingTabbedPane;
    private javax.swing.JPanel SoftDrinksPanel;
    private javax.swing.JPanel SoftDrinksTab;
    private javax.swing.JButton SwitchUserButton;
    private javax.swing.JLabel TabDetailsLabel;
    private javax.swing.JList TabDetailsList;
    private javax.swing.JScrollPane TabDetailsScrollPane;
    private javax.swing.JTextField TabTotalDisplay;
    private javax.swing.JLabel TabTotalLabel;
    private javax.swing.JLabel TablesOrdersListLabel;
    private javax.swing.JLabel TabsListLabel;
    private javax.swing.JPanel TabsPanel;
    private javax.swing.JButton jButton1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton viewTab;
    // End of variables declaration//GEN-END:variables
    
}
