package BartenderUI;
import java.awt.event.*;
import javax.swing.*;
import startbuttons.*;

public class BartenderUI extends JApplet {
    
    /** Initializes the applet BartenderUI */
    public void init() {
        try {
            java.awt.EventQueue.invokeAndWait(new Runnable() {
                public void run() {
                    initComponents();
                }
            });
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        this.setSize(880,700);
        String queryStr="SELECT * FROM menu_items WHERE Type = 00";
        String prefix="bbeer";
        String whatText="Item_name";
        CreateButtons cb = new CreateButtons(BottledBeerPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 10";
        prefix="dbeer";
        cb = new CreateButtons(DraftBeerPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 20";
        prefix="cocktail";
        cb = new CreateButtons(CocktailsPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 30";
        prefix="liquor";
        cb = new CreateButtons(LiquorPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 40";
        prefix="soft";
        cb = new CreateButtons(SoftDrinksPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 50";
        prefix="hot";
        cb = new CreateButtons(HotDrinksPanel,queryStr,prefix,whatText,5,5);        
        queryStr="SELECT * FROM menu_items WHERE Type = 60";
        prefix="apps";
        cb = new CreateButtons(AppetizersPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 70";
        prefix="break";
        cb = new CreateButtons(BreakfastPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 80";
        prefix="luncho";
        cb = new CreateButtons(LunchOtherPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 81";
        prefix="lunchc";
        cb = new CreateButtons(LunchChickenPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 82";
        prefix="lunchs";
        cb = new CreateButtons(LunchSteakPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 83";
        prefix="lunchf";
        cb = new CreateButtons(LunchFishPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 90";
        prefix="dinnero";
        cb = new CreateButtons(DinnerOtherPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 91";
        prefix="dinnerc";
        cb = new CreateButtons(DinnerChickenPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 92";
        prefix="dinners";
        cb = new CreateButtons(DinnerSteakPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 93";
        prefix="dinnerf";
        cb = new CreateButtons(DinnerFishPanel,queryStr,prefix,whatText,5,5);
        queryStr="SELECT * FROM menu_items WHERE Type = 100";
        prefix="dessert";
        cb = new CreateButtons(DessertsPanel,queryStr,prefix,whatText,5,5);
    }
    
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        LogInButton = new javax.swing.JButton();
        LogOutButton = new javax.swing.JButton();
        TabsListLabel = new javax.swing.JLabel();
        OrderReadyButton = new javax.swing.JButton();
        TabDetailsScrollPane = new javax.swing.JScrollPane();
        TabDetailsList = new javax.swing.JList();
        TabTotalTextField = new javax.swing.JTextField();
        TabTotalLabel = new javax.swing.JLabel();
        OrderingPanel = new javax.swing.JPanel();
        OrderingTabbedPane = new javax.swing.JTabbedPane();
        DrinksSpecialsTab = new javax.swing.JPanel();
        DrinksSpecialsPanel = new javax.swing.JPanel();
        DraftBeerTab = new javax.swing.JPanel();
        DraftBeerPanel = new javax.swing.JPanel();
        BottledBeerTab = new javax.swing.JPanel();
        BottledBeerPanel = new javax.swing.JPanel();
        CocktailsTab = new javax.swing.JPanel();
        CocktailsPanel = new javax.swing.JPanel();
        LiquorTab = new javax.swing.JPanel();
        LiquorPanel = new javax.swing.JPanel();
        BreakfastTab = new javax.swing.JPanel();
        BreakfastPanel = new javax.swing.JPanel();
        LunchTab = new javax.swing.JPanel();
        LunchTabbedPane = new javax.swing.JTabbedPane();
        LunchSpecialsTab = new javax.swing.JPanel();
        LunchSpecialsPanel = new javax.swing.JPanel();
        LunchChickenTab = new javax.swing.JPanel();
        LunchChickenPanel = new javax.swing.JPanel();
        LunchFishTab = new javax.swing.JPanel();
        LunchFishPanel = new javax.swing.JPanel();
        LunchSteakTab = new javax.swing.JPanel();
        LunchSteakPanel = new javax.swing.JPanel();
        LunchOtherTab = new javax.swing.JPanel();
        LunchOtherPanel = new javax.swing.JPanel();
        SoftDrinksTab = new javax.swing.JPanel();
        SoftDrinksPanel = new javax.swing.JPanel();
        HotDrinksTab = new javax.swing.JPanel();
        HotDrinksPanel = new javax.swing.JPanel();
        DinnerTab = new javax.swing.JPanel();
        DinnerPanel = new javax.swing.JPanel();
        DinnerTabbedPane = new javax.swing.JTabbedPane();
        DinnerSpecialsTab = new javax.swing.JPanel();
        DinnerSpecialsPanel = new javax.swing.JPanel();
        DinnerChickenTab = new javax.swing.JPanel();
        DinnerChickenPanel = new javax.swing.JPanel();
        DinnerFishTab = new javax.swing.JPanel();
        DinnerFishPanel = new javax.swing.JPanel();
        DinnerSteakTab = new javax.swing.JPanel();
        DinnerSteakPanel = new javax.swing.JPanel();
        DinnerOtherTab = new javax.swing.JPanel();
        DinnerOtherPanel = new javax.swing.JPanel();
        AppetizersTab = new javax.swing.JPanel();
        AppetizersPanel = new javax.swing.JPanel();
        DessertsTab = new javax.swing.JPanel();
        DessertsPanel = new javax.swing.JPanel();
        EmployeeTypeTextField = new javax.swing.JTextField();
        EmployeeNameTextField = new javax.swing.JTextField();
        OpenTabButton = new javax.swing.JButton();
        CloseTabButton = new javax.swing.JButton();
        OrdersScrollPane = new javax.swing.JScrollPane();
        OrdersList = new javax.swing.JList();
        TabsListScrollPane = new javax.swing.JScrollPane();
        TabsList = new javax.swing.JList();
        EmployeeNameLabel = new javax.swing.JLabel();
        TabDetailsLabel = new javax.swing.JLabel();
        TablesOrdersListLabel = new javax.swing.JLabel();

        LogInButton.setFont(new java.awt.Font("Tahoma", 1, 12));
        LogInButton.setText("Log In");

        LogOutButton.setFont(new java.awt.Font("Tahoma", 1, 12));
        LogOutButton.setText("Log Out");

        TabsListLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        TabsListLabel.setText("Tabs List:");

        OrderReadyButton.setFont(new java.awt.Font("Tahoma", 1, 12));
        OrderReadyButton.setText("Order Ready");

        TabDetailsList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "1 Corona Light  $3.00", "1 Bud Light     $2.50", "1 Bud Light     $2.50" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        TabDetailsScrollPane.setViewportView(TabDetailsList);

        TabTotalTextField.setText("$8.00");

        TabTotalLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        TabTotalLabel.setText("Tab Total:");

        OrderingTabbedPane.setFont(new java.awt.Font("Tahoma", 1, 12));
        org.jdesktop.layout.GroupLayout DrinksSpecialsPanelLayout = new org.jdesktop.layout.GroupLayout(DrinksSpecialsPanel);
        DrinksSpecialsPanel.setLayout(DrinksSpecialsPanelLayout);
        DrinksSpecialsPanelLayout.setHorizontalGroup(
            DrinksSpecialsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 535, Short.MAX_VALUE)
        );
        DrinksSpecialsPanelLayout.setVerticalGroup(
            DrinksSpecialsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 547, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout DrinksSpecialsTabLayout = new org.jdesktop.layout.GroupLayout(DrinksSpecialsTab);
        DrinksSpecialsTab.setLayout(DrinksSpecialsTabLayout);
        DrinksSpecialsTabLayout.setHorizontalGroup(
            DrinksSpecialsTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DrinksSpecialsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DrinksSpecialsTabLayout.setVerticalGroup(
            DrinksSpecialsTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DrinksSpecialsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Drinks Specials", DrinksSpecialsTab);

        org.jdesktop.layout.GroupLayout DraftBeerPanelLayout = new org.jdesktop.layout.GroupLayout(DraftBeerPanel);
        DraftBeerPanel.setLayout(DraftBeerPanelLayout);
        DraftBeerPanelLayout.setHorizontalGroup(
            DraftBeerPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 525, Short.MAX_VALUE)
        );
        DraftBeerPanelLayout.setVerticalGroup(
            DraftBeerPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 547, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout DraftBeerTabLayout = new org.jdesktop.layout.GroupLayout(DraftBeerTab);
        DraftBeerTab.setLayout(DraftBeerTabLayout);
        DraftBeerTabLayout.setHorizontalGroup(
            DraftBeerTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DraftBeerTabLayout.createSequentialGroup()
                .add(DraftBeerPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        DraftBeerTabLayout.setVerticalGroup(
            DraftBeerTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DraftBeerPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Draft Beer", DraftBeerTab);

        org.jdesktop.layout.GroupLayout BottledBeerPanelLayout = new org.jdesktop.layout.GroupLayout(BottledBeerPanel);
        BottledBeerPanel.setLayout(BottledBeerPanelLayout);
        BottledBeerPanelLayout.setHorizontalGroup(
            BottledBeerPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 535, Short.MAX_VALUE)
        );
        BottledBeerPanelLayout.setVerticalGroup(
            BottledBeerPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 547, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout BottledBeerTabLayout = new org.jdesktop.layout.GroupLayout(BottledBeerTab);
        BottledBeerTab.setLayout(BottledBeerTabLayout);
        BottledBeerTabLayout.setHorizontalGroup(
            BottledBeerTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(BottledBeerPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        BottledBeerTabLayout.setVerticalGroup(
            BottledBeerTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(BottledBeerPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Bottled Beer", BottledBeerTab);

        org.jdesktop.layout.GroupLayout CocktailsPanelLayout = new org.jdesktop.layout.GroupLayout(CocktailsPanel);
        CocktailsPanel.setLayout(CocktailsPanelLayout);
        CocktailsPanelLayout.setHorizontalGroup(
            CocktailsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 535, Short.MAX_VALUE)
        );
        CocktailsPanelLayout.setVerticalGroup(
            CocktailsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 547, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout CocktailsTabLayout = new org.jdesktop.layout.GroupLayout(CocktailsTab);
        CocktailsTab.setLayout(CocktailsTabLayout);
        CocktailsTabLayout.setHorizontalGroup(
            CocktailsTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(CocktailsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        CocktailsTabLayout.setVerticalGroup(
            CocktailsTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(CocktailsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Cocktails", CocktailsTab);

        org.jdesktop.layout.GroupLayout LiquorPanelLayout = new org.jdesktop.layout.GroupLayout(LiquorPanel);
        LiquorPanel.setLayout(LiquorPanelLayout);
        LiquorPanelLayout.setHorizontalGroup(
            LiquorPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 535, Short.MAX_VALUE)
        );
        LiquorPanelLayout.setVerticalGroup(
            LiquorPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 547, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout LiquorTabLayout = new org.jdesktop.layout.GroupLayout(LiquorTab);
        LiquorTab.setLayout(LiquorTabLayout);
        LiquorTabLayout.setHorizontalGroup(
            LiquorTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(LiquorPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LiquorTabLayout.setVerticalGroup(
            LiquorTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(LiquorPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Liquor", LiquorTab);

        org.jdesktop.layout.GroupLayout BreakfastPanelLayout = new org.jdesktop.layout.GroupLayout(BreakfastPanel);
        BreakfastPanel.setLayout(BreakfastPanelLayout);
        BreakfastPanelLayout.setHorizontalGroup(
            BreakfastPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 535, Short.MAX_VALUE)
        );
        BreakfastPanelLayout.setVerticalGroup(
            BreakfastPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 547, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout BreakfastTabLayout = new org.jdesktop.layout.GroupLayout(BreakfastTab);
        BreakfastTab.setLayout(BreakfastTabLayout);
        BreakfastTabLayout.setHorizontalGroup(
            BreakfastTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(BreakfastPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        BreakfastTabLayout.setVerticalGroup(
            BreakfastTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(BreakfastPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Breakfast", BreakfastTab);

        LunchTabbedPane.setFont(new java.awt.Font("Tahoma", 1, 12));
        org.jdesktop.layout.GroupLayout LunchSpecialsPanelLayout = new org.jdesktop.layout.GroupLayout(LunchSpecialsPanel);
        LunchSpecialsPanel.setLayout(LunchSpecialsPanelLayout);
        LunchSpecialsPanelLayout.setHorizontalGroup(
            LunchSpecialsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 500, Short.MAX_VALUE)
        );
        LunchSpecialsPanelLayout.setVerticalGroup(
            LunchSpecialsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 541, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout LunchSpecialsTabLayout = new org.jdesktop.layout.GroupLayout(LunchSpecialsTab);
        LunchSpecialsTab.setLayout(LunchSpecialsTabLayout);
        LunchSpecialsTabLayout.setHorizontalGroup(
            LunchSpecialsTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, LunchSpecialsTabLayout.createSequentialGroup()
                .addContainerGap(30, Short.MAX_VALUE)
                .add(LunchSpecialsPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );
        LunchSpecialsTabLayout.setVerticalGroup(
            LunchSpecialsTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, LunchSpecialsTabLayout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(LunchSpecialsPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );
        LunchTabbedPane.addTab("Specials", LunchSpecialsTab);

        org.jdesktop.layout.GroupLayout LunchChickenPanelLayout = new org.jdesktop.layout.GroupLayout(LunchChickenPanel);
        LunchChickenPanel.setLayout(LunchChickenPanelLayout);
        LunchChickenPanelLayout.setHorizontalGroup(
            LunchChickenPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );
        LunchChickenPanelLayout.setVerticalGroup(
            LunchChickenPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 518, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout LunchChickenTabLayout = new org.jdesktop.layout.GroupLayout(LunchChickenTab);
        LunchChickenTab.setLayout(LunchChickenTabLayout);
        LunchChickenTabLayout.setHorizontalGroup(
            LunchChickenTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(LunchChickenPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchChickenTabLayout.setVerticalGroup(
            LunchChickenTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, LunchChickenPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchTabbedPane.addTab("Chicken", LunchChickenTab);

        org.jdesktop.layout.GroupLayout LunchFishPanelLayout = new org.jdesktop.layout.GroupLayout(LunchFishPanel);
        LunchFishPanel.setLayout(LunchFishPanelLayout);
        LunchFishPanelLayout.setHorizontalGroup(
            LunchFishPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );
        LunchFishPanelLayout.setVerticalGroup(
            LunchFishPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 518, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout LunchFishTabLayout = new org.jdesktop.layout.GroupLayout(LunchFishTab);
        LunchFishTab.setLayout(LunchFishTabLayout);
        LunchFishTabLayout.setHorizontalGroup(
            LunchFishTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(LunchFishPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchFishTabLayout.setVerticalGroup(
            LunchFishTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(LunchFishPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchTabbedPane.addTab("Fish", LunchFishTab);

        org.jdesktop.layout.GroupLayout LunchSteakPanelLayout = new org.jdesktop.layout.GroupLayout(LunchSteakPanel);
        LunchSteakPanel.setLayout(LunchSteakPanelLayout);
        LunchSteakPanelLayout.setHorizontalGroup(
            LunchSteakPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );
        LunchSteakPanelLayout.setVerticalGroup(
            LunchSteakPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 518, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout LunchSteakTabLayout = new org.jdesktop.layout.GroupLayout(LunchSteakTab);
        LunchSteakTab.setLayout(LunchSteakTabLayout);
        LunchSteakTabLayout.setHorizontalGroup(
            LunchSteakTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(LunchSteakPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchSteakTabLayout.setVerticalGroup(
            LunchSteakTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(LunchSteakPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchTabbedPane.addTab("Steak", LunchSteakTab);

        LunchOtherTab.setFont(new java.awt.Font("Tahoma", 1, 12));
        org.jdesktop.layout.GroupLayout LunchOtherPanelLayout = new org.jdesktop.layout.GroupLayout(LunchOtherPanel);
        LunchOtherPanel.setLayout(LunchOtherPanelLayout);
        LunchOtherPanelLayout.setHorizontalGroup(
            LunchOtherPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );
        LunchOtherPanelLayout.setVerticalGroup(
            LunchOtherPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 518, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout LunchOtherTabLayout = new org.jdesktop.layout.GroupLayout(LunchOtherTab);
        LunchOtherTab.setLayout(LunchOtherTabLayout);
        LunchOtherTabLayout.setHorizontalGroup(
            LunchOtherTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(LunchOtherPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchOtherTabLayout.setVerticalGroup(
            LunchOtherTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(LunchOtherPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        LunchTabbedPane.addTab("Other", LunchOtherTab);

        org.jdesktop.layout.GroupLayout LunchTabLayout = new org.jdesktop.layout.GroupLayout(LunchTab);
        LunchTab.setLayout(LunchTabLayout);
        LunchTabLayout.setHorizontalGroup(
            LunchTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(LunchTabbedPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 535, Short.MAX_VALUE)
        );
        LunchTabLayout.setVerticalGroup(
            LunchTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(LunchTabbedPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 547, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Lunch", LunchTab);

        org.jdesktop.layout.GroupLayout SoftDrinksPanelLayout = new org.jdesktop.layout.GroupLayout(SoftDrinksPanel);
        SoftDrinksPanel.setLayout(SoftDrinksPanelLayout);
        SoftDrinksPanelLayout.setHorizontalGroup(
            SoftDrinksPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 535, Short.MAX_VALUE)
        );
        SoftDrinksPanelLayout.setVerticalGroup(
            SoftDrinksPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 547, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout SoftDrinksTabLayout = new org.jdesktop.layout.GroupLayout(SoftDrinksTab);
        SoftDrinksTab.setLayout(SoftDrinksTabLayout);
        SoftDrinksTabLayout.setHorizontalGroup(
            SoftDrinksTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(SoftDrinksPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        SoftDrinksTabLayout.setVerticalGroup(
            SoftDrinksTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(SoftDrinksPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Soft Drinks", SoftDrinksTab);

        org.jdesktop.layout.GroupLayout HotDrinksPanelLayout = new org.jdesktop.layout.GroupLayout(HotDrinksPanel);
        HotDrinksPanel.setLayout(HotDrinksPanelLayout);
        HotDrinksPanelLayout.setHorizontalGroup(
            HotDrinksPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 535, Short.MAX_VALUE)
        );
        HotDrinksPanelLayout.setVerticalGroup(
            HotDrinksPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 547, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout HotDrinksTabLayout = new org.jdesktop.layout.GroupLayout(HotDrinksTab);
        HotDrinksTab.setLayout(HotDrinksTabLayout);
        HotDrinksTabLayout.setHorizontalGroup(
            HotDrinksTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(HotDrinksPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        HotDrinksTabLayout.setVerticalGroup(
            HotDrinksTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(HotDrinksPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Hot Drinks", HotDrinksTab);

        DinnerTabbedPane.setFont(new java.awt.Font("Tahoma", 1, 12));
        org.jdesktop.layout.GroupLayout DinnerSpecialsPanelLayout = new org.jdesktop.layout.GroupLayout(DinnerSpecialsPanel);
        DinnerSpecialsPanel.setLayout(DinnerSpecialsPanelLayout);
        DinnerSpecialsPanelLayout.setHorizontalGroup(
            DinnerSpecialsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );
        DinnerSpecialsPanelLayout.setVerticalGroup(
            DinnerSpecialsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout DinnerSpecialsTabLayout = new org.jdesktop.layout.GroupLayout(DinnerSpecialsTab);
        DinnerSpecialsTab.setLayout(DinnerSpecialsTabLayout);
        DinnerSpecialsTabLayout.setHorizontalGroup(
            DinnerSpecialsTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerSpecialsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerSpecialsTabLayout.setVerticalGroup(
            DinnerSpecialsTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerSpecialsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerTabbedPane.addTab("Specials", DinnerSpecialsTab);

        org.jdesktop.layout.GroupLayout DinnerChickenPanelLayout = new org.jdesktop.layout.GroupLayout(DinnerChickenPanel);
        DinnerChickenPanel.setLayout(DinnerChickenPanelLayout);
        DinnerChickenPanelLayout.setHorizontalGroup(
            DinnerChickenPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );
        DinnerChickenPanelLayout.setVerticalGroup(
            DinnerChickenPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout DinnerChickenTabLayout = new org.jdesktop.layout.GroupLayout(DinnerChickenTab);
        DinnerChickenTab.setLayout(DinnerChickenTabLayout);
        DinnerChickenTabLayout.setHorizontalGroup(
            DinnerChickenTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerChickenPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerChickenTabLayout.setVerticalGroup(
            DinnerChickenTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerChickenPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerTabbedPane.addTab("Chicken", DinnerChickenTab);

        org.jdesktop.layout.GroupLayout DinnerFishPanelLayout = new org.jdesktop.layout.GroupLayout(DinnerFishPanel);
        DinnerFishPanel.setLayout(DinnerFishPanelLayout);
        DinnerFishPanelLayout.setHorizontalGroup(
            DinnerFishPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );
        DinnerFishPanelLayout.setVerticalGroup(
            DinnerFishPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout DinnerFishTabLayout = new org.jdesktop.layout.GroupLayout(DinnerFishTab);
        DinnerFishTab.setLayout(DinnerFishTabLayout);
        DinnerFishTabLayout.setHorizontalGroup(
            DinnerFishTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerFishPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerFishTabLayout.setVerticalGroup(
            DinnerFishTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerFishPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerTabbedPane.addTab("Fish", DinnerFishTab);

        org.jdesktop.layout.GroupLayout DinnerSteakPanelLayout = new org.jdesktop.layout.GroupLayout(DinnerSteakPanel);
        DinnerSteakPanel.setLayout(DinnerSteakPanelLayout);
        DinnerSteakPanelLayout.setHorizontalGroup(
            DinnerSteakPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );
        DinnerSteakPanelLayout.setVerticalGroup(
            DinnerSteakPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 519, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout DinnerSteakTabLayout = new org.jdesktop.layout.GroupLayout(DinnerSteakTab);
        DinnerSteakTab.setLayout(DinnerSteakTabLayout);
        DinnerSteakTabLayout.setHorizontalGroup(
            DinnerSteakTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerSteakPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerSteakTabLayout.setVerticalGroup(
            DinnerSteakTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerSteakTabLayout.createSequentialGroup()
                .add(DinnerSteakPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        DinnerTabbedPane.addTab("Steak", DinnerSteakTab);

        DinnerOtherTab.setFont(new java.awt.Font("Tahoma", 1, 12));
        org.jdesktop.layout.GroupLayout DinnerOtherPanelLayout = new org.jdesktop.layout.GroupLayout(DinnerOtherPanel);
        DinnerOtherPanel.setLayout(DinnerOtherPanelLayout);
        DinnerOtherPanelLayout.setHorizontalGroup(
            DinnerOtherPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );
        DinnerOtherPanelLayout.setVerticalGroup(
            DinnerOtherPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 519, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout DinnerOtherTabLayout = new org.jdesktop.layout.GroupLayout(DinnerOtherTab);
        DinnerOtherTab.setLayout(DinnerOtherTabLayout);
        DinnerOtherTabLayout.setHorizontalGroup(
            DinnerOtherTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerOtherPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerOtherTabLayout.setVerticalGroup(
            DinnerOtherTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerOtherTabLayout.createSequentialGroup()
                .add(DinnerOtherPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        DinnerTabbedPane.addTab("Other", DinnerOtherTab);

        org.jdesktop.layout.GroupLayout DinnerPanelLayout = new org.jdesktop.layout.GroupLayout(DinnerPanel);
        DinnerPanel.setLayout(DinnerPanelLayout);
        DinnerPanelLayout.setHorizontalGroup(
            DinnerPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerTabbedPane)
        );
        DinnerPanelLayout.setVerticalGroup(
            DinnerPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerTabbedPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 559, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );

        org.jdesktop.layout.GroupLayout DinnerTabLayout = new org.jdesktop.layout.GroupLayout(DinnerTab);
        DinnerTab.setLayout(DinnerTabLayout);
        DinnerTabLayout.setHorizontalGroup(
            DinnerTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DinnerTabLayout.setVerticalGroup(
            DinnerTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DinnerTabLayout.createSequentialGroup()
                .add(DinnerPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        OrderingTabbedPane.addTab("Dinner", DinnerTab);

        org.jdesktop.layout.GroupLayout AppetizersPanelLayout = new org.jdesktop.layout.GroupLayout(AppetizersPanel);
        AppetizersPanel.setLayout(AppetizersPanelLayout);
        AppetizersPanelLayout.setHorizontalGroup(
            AppetizersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 535, Short.MAX_VALUE)
        );
        AppetizersPanelLayout.setVerticalGroup(
            AppetizersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 547, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout AppetizersTabLayout = new org.jdesktop.layout.GroupLayout(AppetizersTab);
        AppetizersTab.setLayout(AppetizersTabLayout);
        AppetizersTabLayout.setHorizontalGroup(
            AppetizersTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(AppetizersPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        AppetizersTabLayout.setVerticalGroup(
            AppetizersTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(AppetizersPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Appetizers", AppetizersTab);

        org.jdesktop.layout.GroupLayout DessertsPanelLayout = new org.jdesktop.layout.GroupLayout(DessertsPanel);
        DessertsPanel.setLayout(DessertsPanelLayout);
        DessertsPanelLayout.setHorizontalGroup(
            DessertsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 535, Short.MAX_VALUE)
        );
        DessertsPanelLayout.setVerticalGroup(
            DessertsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 547, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout DessertsTabLayout = new org.jdesktop.layout.GroupLayout(DessertsTab);
        DessertsTab.setLayout(DessertsTabLayout);
        DessertsTabLayout.setHorizontalGroup(
            DessertsTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DessertsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        DessertsTabLayout.setVerticalGroup(
            DessertsTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(DessertsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        OrderingTabbedPane.addTab("Desserts", DessertsTab);

        org.jdesktop.layout.GroupLayout OrderingPanelLayout = new org.jdesktop.layout.GroupLayout(OrderingPanel);
        OrderingPanel.setLayout(OrderingPanelLayout);
        OrderingPanelLayout.setHorizontalGroup(
            OrderingPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(OrderingPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(OrderingTabbedPane))
        );
        OrderingPanelLayout.setVerticalGroup(
            OrderingPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(OrderingPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(OrderingTabbedPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 593, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        EmployeeTypeTextField.setFont(new java.awt.Font("Tahoma", 1, 12));
        EmployeeTypeTextField.setText("Bartender");

        EmployeeNameTextField.setFont(new java.awt.Font("Tahoma", 1, 12));
        EmployeeNameTextField.setText("Bryan Rabin");

        OpenTabButton.setFont(new java.awt.Font("Tahoma", 1, 12));
        OpenTabButton.setText("Open Tab");

        CloseTabButton.setFont(new java.awt.Font("Tahoma", 1, 12));
        CloseTabButton.setText("Close Tab");

        OrdersList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Order 1 Table 3", "Order 2 Table 9", "Order 3 Table 12", "Order 4 Table 4" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        OrdersScrollPane.setViewportView(OrdersList);

        TabsList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Albert Lalaj", "Moustafa Abdelbaky", "Ling Yang", "Boris Petrovsky", "Bryan Rabin", "Waleed Mina" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        TabsListScrollPane.setViewportView(TabsList);

        EmployeeNameLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        EmployeeNameLabel.setText("Employee Name:");

        TabDetailsLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        TabDetailsLabel.setText("Tab Details:");

        TablesOrdersListLabel.setFont(new java.awt.Font("Tahoma", 1, 12));
        TablesOrdersListLabel.setText("Tables Orders List:");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .addContainerGap()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, LogOutButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, LogInButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 95, Short.MAX_VALUE))
                                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, CloseTabButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, TabsListScrollPane)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, OpenTabButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 105, Short.MAX_VALUE))
                                    .add(TablesOrdersListLabel)))
                            .add(layout.createSequentialGroup()
                                .add(29, 29, 29)
                                .add(TabsListLabel))
                            .add(layout.createSequentialGroup()
                                .addContainerGap()
                                .add(OrdersScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 108, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(38, 38, 38)
                                .add(EmployeeTypeTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 112, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(30, 30, 30)
                                .add(EmployeeNameLabel)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(EmployeeNameTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 271, Short.MAX_VALUE))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(OrderingPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(TabDetailsLabel)
                            .add(TabDetailsScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .addContainerGap()
                        .add(OrderReadyButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 499, Short.MAX_VALUE)
                        .add(TabTotalLabel)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(TabTotalTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 107, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(LogInButton)
                    .add(EmployeeNameTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(EmployeeTypeTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(EmployeeNameLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(LogOutButton)
                        .add(24, 24, 24)
                        .add(TabsListLabel)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(TabsListScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 153, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(OpenTabButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(CloseTabButton)
                        .add(57, 57, 57)
                        .add(TablesOrdersListLabel)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(OrdersScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 246, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(46, 46, 46)
                        .add(TabDetailsLabel)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(TabDetailsScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 545, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(OrderingPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(TabTotalTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(TabTotalLabel)
                    .add(OrderReadyButton))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel AppetizersPanel;
    private javax.swing.JPanel AppetizersTab;
    private javax.swing.JPanel BottledBeerPanel;
    private javax.swing.JPanel BottledBeerTab;
    private javax.swing.JPanel BreakfastPanel;
    private javax.swing.JPanel BreakfastTab;
    private javax.swing.JButton CloseTabButton;
    private javax.swing.JPanel CocktailsPanel;
    private javax.swing.JPanel CocktailsTab;
    private javax.swing.JPanel DessertsPanel;
    private javax.swing.JPanel DessertsTab;
    private javax.swing.JPanel DinnerChickenPanel;
    private javax.swing.JPanel DinnerChickenTab;
    private javax.swing.JPanel DinnerFishPanel;
    private javax.swing.JPanel DinnerFishTab;
    private javax.swing.JPanel DinnerOtherPanel;
    private javax.swing.JPanel DinnerOtherTab;
    private javax.swing.JPanel DinnerPanel;
    private javax.swing.JPanel DinnerSpecialsPanel;
    private javax.swing.JPanel DinnerSpecialsTab;
    private javax.swing.JPanel DinnerSteakPanel;
    private javax.swing.JPanel DinnerSteakTab;
    private javax.swing.JPanel DinnerTab;
    private javax.swing.JTabbedPane DinnerTabbedPane;
    private javax.swing.JPanel DraftBeerPanel;
    private javax.swing.JPanel DraftBeerTab;
    private javax.swing.JPanel DrinksSpecialsPanel;
    private javax.swing.JPanel DrinksSpecialsTab;
    private javax.swing.JLabel EmployeeNameLabel;
    private javax.swing.JTextField EmployeeNameTextField;
    private javax.swing.JTextField EmployeeTypeTextField;
    private javax.swing.JPanel HotDrinksPanel;
    private javax.swing.JPanel HotDrinksTab;
    private javax.swing.JPanel LiquorPanel;
    private javax.swing.JPanel LiquorTab;
    private javax.swing.JButton LogInButton;
    private javax.swing.JButton LogOutButton;
    private javax.swing.JPanel LunchChickenPanel;
    private javax.swing.JPanel LunchChickenTab;
    private javax.swing.JPanel LunchFishPanel;
    private javax.swing.JPanel LunchFishTab;
    private javax.swing.JPanel LunchOtherPanel;
    private javax.swing.JPanel LunchOtherTab;
    private javax.swing.JPanel LunchSpecialsPanel;
    private javax.swing.JPanel LunchSpecialsTab;
    private javax.swing.JPanel LunchSteakPanel;
    private javax.swing.JPanel LunchSteakTab;
    private javax.swing.JPanel LunchTab;
    private javax.swing.JTabbedPane LunchTabbedPane;
    private javax.swing.JButton OpenTabButton;
    private javax.swing.JButton OrderReadyButton;
    private javax.swing.JPanel OrderingPanel;
    private javax.swing.JTabbedPane OrderingTabbedPane;
    private javax.swing.JList OrdersList;
    private javax.swing.JScrollPane OrdersScrollPane;
    private javax.swing.JPanel SoftDrinksPanel;
    private javax.swing.JPanel SoftDrinksTab;
    private javax.swing.JLabel TabDetailsLabel;
    private javax.swing.JList TabDetailsList;
    private javax.swing.JScrollPane TabDetailsScrollPane;
    private javax.swing.JLabel TabTotalLabel;
    private javax.swing.JTextField TabTotalTextField;
    private javax.swing.JLabel TablesOrdersListLabel;
    private javax.swing.JList TabsList;
    private javax.swing.JLabel TabsListLabel;
    private javax.swing.JScrollPane TabsListScrollPane;
    // End of variables declaration//GEN-END:variables
    
}
