

package items;

import net.rim.device.api.ui.component.*;
import net.rim.device.api.ui.container.*;

import listcallback.*;
import itemtypes.*;
import listitems.*;

    public class Appetizers extends MainScreen {
        private  MainScreen  _infoScreen;
        private ObjectListField myList;
        private int select;
        private int n_items=0;
        private String[] items;//={"Mozzarella Sticks","Buffalo Wings","Nachos","Potato Skins","French Fries","Onion Rings",
                               // "Spinach Dip","Chicken Fingers","Fried Shrimp"};
        private BuyableItem buy_item = new BuyableItem();
        private OrderableItem order_item = new OrderableItem();
        private ViewableItem view_item = new ViewableItem();
        private RemovableItem remove_item = new RemovableItem();
        private CommentableItem comment_item = new CommentableItem();
        
        public Appetizers() 
        {          
            super();            
            setTitle(new LabelField("Appetizer Menu", LabelField.ELLIPSIS | LabelField.USE_ALL_WIDTH));
            ListItems theList = new ListItems();
            theList.doQuery("*","menu_items","item_name","Type=60");
            n_items=theList.num_items;
            items = new String[n_items];
            items=theList.items;            
            showListField();            
        }
        
        protected void makeMenu( Menu menu, int instance )
        {
                menu.add(order_item._viewOrderableItem);
                menu.add(buy_item._viewBuyableItem);
                menu.add(view_item._viewableItem);
                menu.add(remove_item._viewRemovableItem);
                menu.add(comment_item._viewCommentableItem);
        }
        
        protected void showListField() 
        {
            ObjectListField myList = new ObjectListField();
            ListCallback myCallback = new ListCallback();
            myList.setCallback(myCallback);
                       
            for(int i=0;i<n_items;i++) {         
                myCallback.add(myList,items[i],i);
            }
            
            add(myList);
            order_item.myList=myList;
            order_item.myCallback=myCallback;
            order_item.items=items;
            buy_item.myList=myList;
            buy_item.myCallback=myCallback;
            view_item.myList=myList;
            view_item.myCallback=myCallback;
            remove_item.myList=myList;
            remove_item.myCallback=myCallback;
            comment_item.myList=myList;
            comment_item.myCallback=myCallback;

        }
        
        public void changeMenu(String[] newNames) 
        {
            items=newNames;
            showListField();
        }
} 
    

    




