
package listcallback;

import java.util.*;
import net.rim.device.api.ui.*;
import net.rim.device.api.ui.component.*;

public class ListCallback implements ListFieldCallback {
       private Vector listElements = new Vector();

       public void drawListRow(ListField list, Graphics g, int index, int y, int w)
       {
           String text = (String)listElements.elementAt(index);
           g.drawText(text, 0, y, 0, w);
       }

       public Object get(ListField list, int index) {
           return listElements.elementAt(index);
           }

       public int indexOfList(ListField list, String p, int s) {  
           return listElements.indexOf(p, s);
           }
           
       public int getPreferredWidth(ListField list) {
         return Graphics.getScreenWidth();
           }

       public void add(ListField list, String toInsert, int index) {
           list.insert(index);
           insert(toInsert,index);
        }

       public void insert(String toInsert, int index) {
           listElements.addElement(toInsert);
           }
          
       public void erase() {
           listElements.removeAllElements();
           }
       };
